package cc.fascinated.wildaddons.addon.impl.chat;

import cc.fascinated.wildaddons.Main;
import cc.fascinated.wildaddons.addon.Addon;
import cc.fascinated.wildaddons.listener.PlayerListener;
import cc.fascinated.wildaddons.statistic.Statistic;
import cc.fascinated.wildaddons.utils.PlayerUtils;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import java.util.concurrent.ThreadLocalRandom;

public class AutoWelcomerAddon extends Addon {

    private final boolean autoWelcome = true;
    private boolean waitingForReply = false;

    public AutoWelcomerAddon() {
        super("Auto Welcomer", "Automatically sends the welcome command when a new player joins.", Category.CHAT);

        // TODO: actually check if we got the gem for welcoming
    }

    @Override
    public void onChat(String message, String messageStripped, CallbackInfo ci) {
        if (!this.isEnabled()) { // This addon is disabled
            return;
        }

        if (waitingForReply && messageStripped.startsWith("+1 Gem for welcoming")) {
            Statistic.PLAYERS_WELCOMED.increment(); // Increment the stat
            waitingForReply = false;
            return;
        }

        if (!PlayerListener.isMoving()) { // To prevent bans lol
            return;
        }
        if (!messageStripped.startsWith("WILDNETWORK » Welcome")) { // This is not the message we are looking for
            return;
        }
        String[] parts = messageStripped.split(" ");
        String name = parts[2];

        // No need to welcome ourselves
        if (Main.getMinecraftClient().player.getName().getString().equals(name)) {
            return;
        }

        if (!autoWelcome) { // Stop running if auto welcome is disabled
            return;
        }

        Main.getExecutorService().execute(() -> {
            try {
                // Sleep the thread for a randomized amount of time to make it look less suspicious
                Thread.sleep(ThreadLocalRandom.current().nextLong(600, 2000));
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
            PlayerUtils.sendMessage("/wc"); // Send the command

            waitingForReply = true;
        });

    }
}
