package cc.fascinated.wildaddons.addon.impl.chat;

import cc.fascinated.wildaddons.Main;
import cc.fascinated.wildaddons.addon.Addon;
import cc.fascinated.wildaddons.statistic.Statistic;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import java.util.Arrays;
import java.util.List;

public class MessageFilterAddon extends Addon {

    private final List<String> toRemove = Arrays.asList(
            "⛃ Blessing",
            "✌ OP CRATE",
            "✌ VOTE",
            "RANKS",
            //"has just won a",
            "+ KeyFinder",
            "ALERT",
            "WILDPASS"
    );

    private String lastMessage = null;

    public MessageFilterAddon() {
        super("Chat Filter", "Removes all the junk messages from chat.", Category.CHAT);
    }

    @Override
    public void onChat(String message, String messageStripped, CallbackInfo ci) {
        Main.getMinecraftClient().inGameHud.getChatHud().addToMessageHistory("");
        if (lastMessage != null && lastMessage.equals(message)) { // Fixes double new lines for certain messages
            ci.cancel();
            return;
        }
        lastMessage = message;

        if (messageStripped.equals("----------------------------------------------------")) {
            ci.cancel();
            Main.getMinecraftClient().inGameHud.getChatHud().addToMessageHistory("");
            return;
        }

        for (String check : toRemove) {
            if (messageStripped.startsWith(check)) {
                ci.cancel();
                Statistic.FILTERED_MESSAGES.increment();
            }
        }
    }
}
