package cc.fascinated.wildaddons.listener;

import cc.fascinated.wildaddons.Main;
import cc.fascinated.wildaddons.event.EventListener;
import cc.fascinated.wildaddons.utils.PlayerUtils;
import net.minecraft.client.network.ClientPlayerEntity;

public class PlayerListener implements EventListener {

    /**
     * The last time the player moved.
     */
    private static long lastMovement;

    @Override
    public void onTick(int ticksPassed) {
        if (!PlayerUtils.isOnWild()) { // Ignore if the player isn't on Wild
            return;
        }
        ClientPlayerEntity player = Main.getMinecraftClient().player;
        if (player == null) {
            return;
        }
        if (player.getX() - player.prevX > 0 || player.getY() - player.prevY > 0 ||
                player.getZ() - player.prevZ > 0) { // Check if the player has moved
            lastMovement = System.currentTimeMillis();
        }
    }

    /**
     * Checks if the player has moved
     * in the last 10 seconds.
     *
     * @return true if they are moving, otherwise false
     */
    public static boolean isMoving() {
        return (System.currentTimeMillis() - lastMovement) < 10_000L;
    }
}
