package cc.fascinated.wildaddons.mixin;

import cc.fascinated.wildaddons.Main;
import cc.fascinated.wildaddons.event.EventListener;
import cc.fascinated.wildaddons.event.EventManager;
import cc.fascinated.wildaddons.utils.PlayerUtils;
import net.minecraft.client.MinecraftClient;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(MinecraftClient.class)
public class MinecraftClientMixin {

    /**
     * The total amount of ticks since mod initialization
     */
    private int ticksPassed = 0;

    @Inject(method = "tick", at = @At("HEAD"))
    public void onTick(CallbackInfo ci) {
        ticksPassed++;
        if (!PlayerUtils.isOnWild()) { // Ignore if the player isn't on Wild
            return;
        }
        if (Main.getMinecraftClient().player == null) {
            return;
        }
        for (EventListener listener : EventManager.getListeners()) {
            listener.onTick(ticksPassed);
        }
    }
}
