package cc.fascinated.wildaddons.utils;

import java.text.DecimalFormat;

public class NumberUtils {

    private static final DecimalFormat formatter = new DecimalFormat("##.##");
    private static final DecimalFormat commaFormatter = new DecimalFormat("#,###");
    static {
        formatter.setMinimumFractionDigits(2);
        formatter.setMaximumFractionDigits(2);
    }

    /**
     * Formats the given number.
     *
     * @param number the number to format
     * @param withCommas use commas
     * @return the formatted number
     */
    public static String format(Object number, boolean withCommas) {
        return withCommas ? commaFormatter.format(number) : formatter.format(number);
    }

    /**
     * Formats the given number.
     *
     * @param number the number to format
     * @return the formatted number
     */
    public static String format(Object number) {
        return format(number, false);
    }
}
