package cc.fascinated.wildaddons.utils;

import cc.fascinated.wildaddons.Main;
import net.minecraft.client.network.ServerInfo;

public class PlayerUtils {

    /**
     * Sends a chat message as the player.
     *
     * @param message the message to send
     */
    public static void sendMessage(String message) {
        Main.getMinecraftClient().player.networkHandler.sendChatMessage(message);
    }

    /**
     * Checks the given ip against the
     * currently connected servers ip.
     *
     * @param ips the server ips
     * @return true if same, otherwise false
     */
    public static boolean onServer(String... ips) {
        ServerInfo currentServerEntry = Main.getMinecraftClient().getCurrentServerEntry();
        if (currentServerEntry == null) {
            return false;
        }
        for (String ip : ips) {
            if (currentServerEntry.address.toLowerCase().contains(ip)) {
                return true;
            }
        }
        return false;
    }

    /**
     * Checks if the player is currently on wild.
     *
     * @return true if on wild, otherwise false
     */
    public static boolean isOnWild() {
        return onServer("wildprison.net", "wildnetwork.net");
    }

    /**
     * Gets the current servers ip
     *
     * @return the ip
     */
    public static String getCurrentServerIp() {
        ServerInfo currentServerEntry = Main.getMinecraftClient().getCurrentServerEntry();
        if (currentServerEntry == null) {
            return null;
        }
        return currentServerEntry.address;
    }
}
